#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <errno.h>

#include <X11/X.h>
#include <X11/Xutil.h>
#include <X11/keysymdef.h>
#include <X11/extensions/XTest.h>
#include <X11/XKBlib.h>
#include <X11/extensions/xf86vmode.h>
#define PN "i810pan: "


static Display *display;
static Window root_window;
static int x, y, w, h;
static int mouse_x, mouse_y;
static int viewport_x, viewport_y;
static unsigned int button_mask;
static off_t base;
static int memfd;
static int panel_w, panel_h;
static int tile_off_x, tile_off_y;
static int bound_l, bound_r, bound_t, bound_b;


int main(int argc, char *argv[]) {
  const char *display_name, *tmp_str;
  Window root_return, child_return;
  int dummy, i;
  unsigned int tmp;

        // TODO: figure out real panel dimensions 
  panel_w = 800;
  panel_h = 480;

        // set the initial tile boundaries
  bound_t = 0;
  bound_b = panel_h;
  bound_l = 0;
  bound_r = panel_w;

        // try to open the display
  display_name = getenv("DISPLAY");
  if(!display_name) display_name = ":0.0";
  display = XOpenDisplay(display_name);
  if(!display) {
    fprintf(stderr, PN "can't open X display %s", display_name);
    return 1;
  }

        // get the root window and screen dimensions
  root_window = DefaultRootWindow(display);
  x = 0;
  y = 0;
  w = WidthOfScreen(DefaultScreenOfDisplay(display));
  h = HeightOfScreen(DefaultScreenOfDisplay(display));

  fprintf(stderr, PN "screen size: %dx%d\n", w, h);


  while("x.org is busy disabling useful features") {
    struct timeval tv = { 0, 100000 };
    select(0, NULL, NULL, NULL, &tv);
nowait:
        // get the current viewport.
    XF86VidModeGetViewPort(display, 0, &viewport_x, &viewport_y);

                if(XQueryPointer(display, root_window, &root_return, &child_return, &mouse_x, &mouse_y, &dummy, &dummy, &button_mask)) {
#ifdef DEBUG
                        fprintf(stderr, PN "X pointer is at %d,%d\n",mouse_x,mouse_y);
                        fprintf(stderr, PN "Viewport is at %d,%d\n",viewport_x,viewport_y);

#endif
                if (mouse_x > bound_r && bound_r < w - 1) {
  tile_off_x += 5;
  bound_l = tile_off_x;
  bound_r = bound_l + panel_w;
  mouse_x += 5;
                } else if (mouse_x < bound_l) {
                  tile_off_x -= 5;
                  bound_l = tile_off_x;
                  bound_r = bound_l + panel_w;
                  mouse_x -= 5;
                };
                if (mouse_y > bound_b && bound_b < w - 1) {
                  tile_off_y += 5;
                  bound_t = tile_off_y;
                  bound_b = bound_t + panel_h;
                  mouse_y += 5;
                } else if (mouse_y < bound_t) {
                  tile_off_y -= 5;
                  bound_t = tile_off_y;
                  bound_b = bound_t + panel_h;
                  mouse_y -= 5;
                };

                if (bound_b >= h) {
                  bound_b = h;
                  bound_t = bound_b - panel_h;
                };
                if (bound_r >= w) {
                  bound_r = w;
                  bound_l = bound_r - panel_w;
                };

                XF86VidModeSetViewPort(display, 0, tile_off_x, tile_off_y);

#ifdef DEBUG
                        fprintf(stderr, PN "   Viewport is at %d,%d - %d,%d\n", tile_off_x, tile_off_y, tile_off_x+panel_w, tile_off_y+panel_h);
                        fprintf(stderr, PN "pointer is at %d,%d\n", mouse_x, mouse_y);
#endif
      // determine if the pointer's in the viewport yet.
      // Viewport is from location tile_off_x, tile_off_y to tile_off_x + w, tile_off_y + h;
      if ((mouse_x > tile_off_x+panel_w) || (mouse_x < tile_off_x) || (mouse_y > tile_off_y+panel_h) || (mouse_y < tile_off_y)) {goto nowait;}

                } else {
                  fprintf(stderr, PN "can't query pointer\n");
                }
  }


  // just in case we become a properly terminating program some day
  XCloseDisplay(display);
  return 0;
}
